var Transform = require('stream').Transform

module.exports = function () {
  var liner = new Transform({objectMode: true})

  liner._transform = function (chunk, encoding, done) {
    var data = chunk.toString()
    if (this._lastLineData) {
      data = this._lastLineData + data
    }

    var lines = data.split('\n')
    this._lastLineData = lines.splice(lines.length - 1, 1)[0]

    /* 没有按照反馈机制的要求实现 ，完全依赖buffer满后的反馈机制，停止transform调用*/
    lines.forEach(this.push.bind(this))
    done()
  }

  liner._flush = function (done) {
    if (this._lastLineData) {
      this.push(this._lastLineData)
    }
    this._lastLineData = null
    done()
  }

  return liner
}
